'use strict';

var binarySearch = require('binary-search');
var numSort = require('num-sort');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var binarySearch__default = /*#__PURE__*/_interopDefaultLegacy(binarySearch);

/**
 *
 * @param {object} points
 * @param {Array<number>} originalPoints.x
 * @param {Array<number>} originalPoints.y
 * @param {*} options
 * @return {{x: Array<number>, y: Array<number>}}
 */
function closestX(points, options) {
  const { x, y } = points;
  const { target = x[0], reverse = false } = options;

  let index;
  if (reverse) {
    index = binarySearch__default['default'](x, target, numSort.descending);
  } else {
    index = binarySearch__default['default'](x, target, numSort.ascending);
  }

  if (index >= 0) {
    return {
      x: x[index],
      y: y[index],
    };
  } else {
    index = ~index;
    if (
      (index !== 0 && Math.abs(x[index] - target) > 0.5) ||
      index === x.length
    ) {
      return {
        x: x[index - 1],
        y: y[index - 1],
      };
    } else {
      return {
        x: x[index],
        y: y[index],
      };
    }
  }
}

module.exports = closestX;
